
# aliquot.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": aliquot sequences (sociable chains)
# https://en.wikipedia.org/wiki/Aliquot_sequence

# inputs:  24, 28, 220, 284, 12496, 14316, 1264460 
# long: 138;   very long: 840
# infinity?: 276, 552



import pUtils


def aliquotSeq(n):
  print(n, end=" ", flush=True) 
  s = set() 
  s.add(n) 
  while n != 1: 
    # Calculate next term from previous term 
    n = sum(pUtils.divisors(n, isProper=True)) 
    if n in s: 
      print(n, "**cycle**") 
      return False
    print(n, end=" ", flush=True) 
    s.add(n) 
  print()
  return True


n = int(input("n? "))
res = aliquotSeq(n)
print("Is an aliquot sequence?", res)
