
# amicable.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": amicable numbers
# https://en.wikipedia.org/wiki/Amicable_numbers
# https://oeis.org/A259180

import pUtils

def s(n):
  return pUtils.sigma(n)-n


limit = 20000
n2divsum = {n:s(n) for n in range(1, limit+1)}

print(f"Amicable Pairs <= {limit}:")
for num, ds in n2divsum.items():
  if (num < ds) and (ds <= limit) and \
     (n2divsum[ds] == num):
    print(f' {num:5d}  {ds:5d}')
    # print("  ", pUtils.divisors(num, isProper=True))
    # print("  ", pUtils.divisors(ds, isProper=True))
