
# andrica.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Andrica’s coniecture
# https://en.wikipedia.org/wiki/Andrica%27s_conjecture


import math
import pUtils
import matplotlib.pyplot as plt

ps = pUtils.primesNum(200)
rootDiffs = []
for i in range(len(ps)-1):
  rootDiffs.append(math.sqrt(ps[i+1]) - math.sqrt(ps[i]))

plt.plot(range(1,len(ps)), rootDiffs)
plt.xlabel("n")
plt.ylabel("A(n)")
plt.title("Andrica's Conjecture")

plt.show()


