
# bang.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Bang's theorem
# https://math.stackexchange.com/questions/2251/for-any-n-is-there-a-prime-factor-of-2n-1-which-is-not-a-factor-of-2m-1
# https://en.wikipedia.org/wiki/Zsigmondy%27s_theorem

import pUtils

def overlaps(lst1, lst2):
  lst3 = [v for v in lst1 if v in lst2]
  return lst3 != []


def checkBangs(n):
  nFacs = pUtils.primeFactors(2**n - 1)
  for k in range(1, n):
    kFacs = pUtils.primeFactors(2**k - 1)
    if overlaps(nFacs, kFacs):
      if n == 6:
        continue  # ignore n = 6
      print(f"Prime divs of 2^{n}-1 overlap 2^{k}-1")
      return
  print(f"Bang holds for n = {n}")


for n in range(2, 11):
  checkBangs(n)

