
# bertrand.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Bertrand's Postulate
# https://en.wikipedia.org/wiki/Bertrand%27s_postulate

import pUtils


limit = 100000
isBertrand = True
for n in range(3, limit+1):
  hasPrime = any(pUtils.isPrime(p) 
                       for p in range(n, 2*n-1))
  if not hasPrime:
    print(f"Bertrand fails for n = {n}")
    isBertrand = False
    break

if isBertrand:
  print(f"Bertrand holds for n = 3 to {limit}")
