
# bonse.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Bonse’s inequality
# https://en.wikipedia.org/wiki/Bonse%27s_inequality

import math
import pUtils



limit = 100
prims = pUtils.primes(limit)

isBonse = True
for n in range(4, len(prims)):
  p = prims[n]
  prods = math.prod(prims[:n])
  if p*p >= prods:
    print(f"Bonse fails at p_{n} = {p}, prods = {prods}")
    isBonse = False
    break

if isBonse:
  print("Bonse holds for",  prims[4], "--", prims[-1]) 

