
# brocard.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Brocard's conjecture (2nd)
# https://en.wikipedia.org/wiki/Brocard%27s_conjecture
# https://mathworld.wolfram.com/BrocardsConjecture.html
# https://oeis.org/A050216

import math
import pUtils
import matplotlib.pyplot as plt


pEst = pUtils.primes_nthEst(200)
ps = pUtils.primes(pEst+1)

countDiffs = []
for i in range(len(ps)-1):
  countDiffs.append(pUtils.pi(ps[i+1]**2) - pUtils.pi(ps[i]**2))
print(*countDiffs)

plt.plot(range(1,len(ps)), countDiffs)
plt.xlabel("n")
plt.ylabel("B(n)")
plt.title("Brocard's Conjecture")
plt.show()
