
# buss.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Buss's function
# https://www.primepuzzles.net/conjectures/conj_029.htm

import pUtils

limit = 15
fs = [0]*(limit+1)

def buss(n):
  return nextPrime(f(n)+1) - f(n) 

def nextPrime(n):
  count = 0; prime = 0
  n += 1  # skip over starting number
  while True:
    if pUtils.isPrime(n):
      return n
    n += 1

def f(n):
  if n == 1:
    return 1
  if fs[n] == 0:
    fs[n] = f(n-1)*buss(n-1)
  return fs[n]


print("n f(n) next-prime B(n)")
for i in range(1, limit+1):
  print(i, f(i), nextPrime(f(i)+1), buss(i))

