
# carmichaelTot.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Euler, Leonhard (1707-1783), Carmichael’s totient function conjecture
# https://en.wikipedia.org/wiki/Carmichael%27s_totient_function_conjecture
'''
Carmichael conjectured that if phi(n)=k then 
there is another number, n2, where phi(n2)=k also. 
The conjecture is known to be true for all values of 
phi(n) up 10^1360000.
'''

import pUtils

limit = 200
phis = []
phi2i = {}  # phi and i's that generate it
for i in range(1, limit+1):
  p = pUtils.phi(i)
  phis.append(p)
  phi2i.setdefault(p, []).append(i)

print(f"phis for n = 1 to {limit}:")
print(phis)

print(f"\nphi results from n = 1 to {limit//2}:")
phi2i = dict(sorted(phi2i.items()))
print(" phi :  n's")
for p in phi2i.keys():
  if p > limit/2:
    break
  print(f" {p:3d} :", phi2i[p])

