
# circle.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": circle, prime
# https://mathworld.wolfram.com/PrimeCircle.html
# input: 3,    4
'''
To generate a prime circle in Python where adjacent 
pairs sum to primes, we need to:
* Generate numbers 1 to 2*n
* Arrange these numbers in a circle such that the sum of 
  each adjacent pair is also a prime number.
* Use backtracking to find a permutation.
'''

import pUtils


def primeCircle(nums, circle, used, index):
  global circleCount
  if index == len(nums):
    # do the last number and the first form a prime sum
    if pUtils.isPrime(circle[0] + circle[-1]):
      print(circle)
      circleCount += 1
  
  for i in range(1, len(nums)):
    if not used[i]:
      # Can this prime be adjacent to the previous number
      if pUtils.isPrime(circle[index-1] + nums[i]):
        circle[index] = nums[i]
        used[i] = True
        primeCircle(nums, circle, used, index+1)
        used[i] = False



n = int(input("n? "))  
nums = list(range(1, 2*n+1))
print(f"Nums: {nums}")

circleCount = 0
circle = [-1] * len(nums)
circle[0] = nums[0]  # Fix the first number
used = [False] * len(nums)
used[0] = True

primeCircle(nums, circle, used, 1)

print("Num. valid prime circles:", circleCount)
