
# circulars.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Circular prime
# https://en.wikipedia.org/wiki/Circular_prime
# https://oeis.org/A016114

import pUtils

def isCirclePrime(n):
  s = str(n)
  return all(int(s[i:]+s[:i]) in ps
                         for i in range(len(s)))


ps = set(pUtils.primes(1000000))
cPs = [i for i in range(len(ps)) if isCirclePrime(i)]
# print(cPs)

# remove numerical anagrams
sortedPs =  [sorted(str(num)) for num in cPs]
uniquePs = [cPs[0]]
for i in range(1, len(sortedPs)):
  if sortedPs[i] not in sortedPs[:i]:
    uniquePs.append(cPs[i])

print(*uniquePs)
print("Count:", len(uniquePs))  # 17


