
# consecNums.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": consecutive numbers
# https://en.wikipedia.org/wiki/Bertrand%27s_postulate
#  -- see "Sylvester's theorem subsection
# input:  6   or  10
'''
Sylvester's theorem on the product of k consecutive 
integers > k, that generalizes Bertrand's postulate. Pick 
a positive integer k and take the product of k consecutive 
integers greater than k. Then the result is divisible by 
a prime number greater than k
'''

import math, random
import pUtils

k = int(input("k? "))

start = random.randint(k+1, 5*k)
nums = list(range(start, start+k))
print(f"Randomly chose {start}, and generated:", nums)

tot = math.prod(nums)
print("Product:", tot)

factors = pUtils.primeFactors(tot)
print("Prime factors:", factors)

isSmaller = True
print(f"Factors greater than {k}:")
for f in factors:
  if f > k:
    print(f, end=' ')
    isSmaller = False
if isSmaller:
  print("All factors <=", k)
else:
  print()

