
# consecPrimes.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# inputs:   41  or  5
# David Wells - "Prime Numbers": consecutive primes, sums of
# Guy, "Unsolved Problems in Intuitive Mathematics", C2

import math
import pUtils

def f(n):
  return len(consec_primeSums(n))

def consec_primeSums(n):  
  # Find all ways to express n as a sum of consecutive primes
  primes = pUtils.primes(n+1)
  sums = []
  for start in range(len(primes)):
    currSum = 0
    for end in range(start, len(primes)):
      currSum += primes[end]
      if currSum == n:
        sums.append(primes[start:end+1])  
        break     # the consecutive prime seq
      elif currSum > n:
        break
  return sums

n = int(input("n? "))
cpSums = consec_primeSums(n)
numSums = len(cpSums)
if numSums > 0:
  print(n, "can be expressed in", numSums, "ways:")
  for seq in cpSums:
    print(" + ".join(map(str, seq)))
else:
  print(n, "cannot be expressed as the sum of consecutive primes.")


# -----------------------------------------
print()
print("f(5) =", f(5))
print("f(41) =", f(41))

x = 1000
print(f"Moser theorem for x = {x}:")
moser = sum([ f(n) for n in range(1, x+1)])/x
print(moser, "; log(2)=", math.log(2))

