
# coprimePlot.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# https://mathworld.wolfram.com/RelativelyPrime.html

import math
import matplotlib.pyplot as plt
import matplotlib.cm as cm


limit = 101
# Create an array of boolean values: 
# T for coprime, F for others
coprimes = [[False for y in range(limit)] 
                              for x in range(limit)]
for i in range(1, limit+1):
  for j in range(1, limit+1):
    if math.gcd(i, j) == 1:
      coprimes[i-1][j-1] = True
plt.matshow(coprimes, cmap=cm.binary, origin='lower')
plt.gca().xaxis.tick_bottom()
plt.title('Coprime pairs')
plt.show()

