
# coprimeScatter.py
# https://demonstrations.wolfram.com/GeneratingAllCoprimePairs/

import math
import matplotlib.pyplot as plt


def extendGen(pairs):
  res = []
  for pair in pairs:
    m, n = pair
    b1 = (2*m-n, m)
    b2 = (2*m+n, m)
    b3 = (m+2*n, n)
    res.extend([b1, b2, b3])
  return res


def plotPairs(plt, pairsList, label):
  ms, ns = zip(*pairsList)
  plt.scatter(ms, ns, label=label, s=8, alpha=0.7)


maxGen = 5
plt.figure(figsize=(8, 6))

gen = [(2,1), (3,1)]
plotPairs(plt, gen, 'Gen 0')
for i in range(1, maxGen+1):
  gen = extendGen(gen)
  plotPairs(plt, gen, "Gen " + str(i))

plt.title('Coprime Pairs (m, n) colored by Generation')
plt.xlabel('m')
plt.ylabel('n')
plt.legend()
plt.show()

