
# densityPrimes.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# https://t5k.org/howmany.html ; end of section 2


import math
import matplotlib.pyplot as plt
import pUtils
from frange import linspace

limit = 1000000
prims = pUtils.primes(limit)

numBins = 50
binSize = limit/numBins
print("Bin size:", binSize)
print("binSize/log(limit):", binSize/math.log(limit))

plt.figure(figsize=(10, 4))

plt.hist(prims, numBins, rwidth=0.4, label='No. of primes per bin')
ts = linspace(2+(binSize/2), limit, numBins)
us = [ binSize/math.log(t) for t in ts]
plt.plot(ts, us, lw=2, label='binSize/math.log(p)')

plt.title(f"Primes per bin Density < {limit}")
plt.xlabel("Primes, p")
plt.ylabel("No. of primes per bin")
plt.legend()
plt.show()

