
# descriptive.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": descriptive primes
# https://en.wikipedia.org/wiki/Look-and-say_sequence
# inputs: 373  or  19972667609
'''
   Generate the first n values in the look-and-say sequence. 
   The look-and-say sequence starting with '1' is:

    1, 11, 21, 1211, 111221, 312211, 13112221, 
    1113213211, 31131211131221, ... 

   To generate a number read off the digits of the 
   previous number, counting the number of digits in groups 
   of the same digit.

   Are there sequences whose terms are all prime? 
   Honaker Jr. found: 
      373, 131713, 111311171113, 311331173113
'''

import pUtils

def lookandsay(n):
  nStr = str(n)
  result = ""
  repeat = nStr[0]
  nStr = nStr[1:]+" "
  mult = 1
  for n in nStr:
    if n != repeat:
      result += str(mult)+repeat
      mult = 1
      repeat = n
    else:
      mult += 1
  return int(result)


n = int(input("n? "))
count = 1
while pUtils.isPrime(n):
  print(f"{count}. {n}")
  n = lookandsay(n)
  count += 1
print(f"{count}. {n} composite")
