
# digitalRoots.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
'''
All known prime numbers greater than 3 have digital 
roots of 1, 2, 4, 5, 7, or 8.
'''

import pUtils
import matplotlib.pyplot as plt
from collections import Counter

def digitalRoot(n):
  return 1 + (n-1)%9  # (base 10)


limit = 10000
primes = pUtils.primes(5, limit)
primeDRs = [digitalRoot(p) for p in primes]

rootCounts = Counter(primeDRs)
plt.bar(rootCounts.keys(), rootCounts.values())
plt.xlabel('Digital Root')
plt.ylabel('Freq')
plt.title('Distribution of Digital Roots of Prime Numbers > 3')
plt.show()
