
# divisors.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": divisors (factors)
# https://en.wikipedia.org/wiki/Divisor_function

import math
import pUtils


print("Record numbers of divisors:")
dn = 0
for i in range(2, 150):
  numDs = pUtils.numDivisors(i)
  if numDs > dn:
    print(i, pUtils.factorize(i), numDs)
    dn = numDs

print("\nConsecutive numbers with the same divisors:")
for i in range(2, 100):
  numDs1 = pUtils.numDivisors(i)
  numDs2 = pUtils.numDivisors(i+1)
  if numDs1 == numDs2:
    print(i, i+1, numDs1)

print("\nSigma values up to 20")
for i in range(2, 21):
  print(i, pUtils.isPrime(i), pUtils.factorize(i), 
                              pUtils.sigma(i))

print("\nSize of sigma")
for n in [100, 1000, 10000, 1000000]:
  print(n, pUtils.sigma(n)/(n*math.sqrt(n)))

print("\nSum of sigmas 1 to 1000:")
print( sum([pUtils.sigma(i) for i in range(1,1001)]))


