
# divisorsPlot.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": divisors (factors)
# https://en.wikipedia.org/wiki/Divisor_function


import math
import pUtils
import matplotlib.pyplot as plt


max = 200
xs = list(range(1, max+1))
ys = [pUtils.sigma(n) for n in xs] 

# print("σ(n):", ys)
ss = [s/(n*math.sqrt(n)) for s, n in enumerate(ys)]
# print("σ(n)/(n*sqrt(n)):", ss)


plt.figure(figsize=(12, 5))

plt.subplot(1, 2, 1)   # rows, columns, plot idx
plt.plot(xs, ys, marker='o', lw=0.5, ms=2)
plt.title("σ(n)")
plt.xlabel('n')
plt.ylabel('σ(n)')

plt.subplot(1, 2, 2)   # rows, columns, plot idx
plt.plot(xs, ss, marker='o', lw=0.5, ms=2)
plt.title("σ(n)/(n*√n)")
plt.xlabel('n')
plt.ylabel('σ(n)/(n*√n)')

plt.show()
