
# ellipticPlot.py
# inputs for a, b: 0 -1 or 0 1 or -1 0 or -7 6 or -2 4


import matplotlib.pyplot as plt
import math

a,b = map(float, input("a b? ").split())

xs = [x * 0.1 for x in range(-40, 41)] 

ysPos = []
ysNeg = []
# Calculate y values for each x
for x in xs:
  rhs = x**3 + a*x + b
  if rhs >= 0:  # Only calculate y if rhs is non-negative
    y = math.sqrt(rhs)
    ysPos.append((x, y))
    ysNeg.append((x, -y))

# Separate x and y coords for plotting
xsP, ysP = zip(*ysPos) if ysPos else ([], [])
xsN, ysN = zip(*ysNeg) if ysNeg else ([], [])


plt.plot(xsP, ysP, color='blue')
plt.plot(xsN, ysN, color='blue')

plt.xlabel("x")
plt.ylabel("y")
plt.title(f"Elliptic Curve: $y^2 = x^3 + {a}x + {b}$")
plt.axhline(0, color='black')
plt.axvline(0, color='black')
plt.grid(True)
plt.axis('square')
plt.xticks(range(-4, 5))
plt.yticks(range(-4, 5))
plt.xlim(-4, 4)
plt.ylim(-4, 4)
plt.show()
