
# euclid.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Euclid (c. 330-270 BC)
'''
Generate primes
  - see the "Euclid and the infinity of primes" subsection
'''
import pUtils
import math

print("Generate Euclid primes:")
limit = 7
print("Start with 2")
primes = [2]
while primes[-1] < 1000000:
  eNum = math.prod(primes)+1  
  print("Factorize", '*'.join(map(str, primes))+"+1 =", eNum)
    # either prime or has at least two prime factors
  facts = pUtils.primeFactors(eNum)
  if len(facts) == 1:
    print(" - prime")
    primes.append(eNum)
  else:
    print(f" - composite: {facts}")
    for f in facts:
      if f not in primes:
        print(f"{f} is a new prime")
        primes.append(f)

print("\nEuclid primes:", sorted(primes))


