
# euclidMullin.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Euclid (c. 330-270 BC)
# https://en.wikipedia.org/wiki/Euclid%E2%80%93Mullin_sequence
'''
Generate primes
  - see the "a recursive sequence" subsection

The Euclid–Mullin sequence is an infinite sequence of 
distinct prime numbers, in which each element is the 
least prime factor of one plus the product of all 
earlier elements.
'''

import math
import pUtils

limit = 12 
print("Start with 2")
seq = [2]  # a_1 = 2
for _ in range(1, limit):
  v = math.prod(seq) + 1
  smallestPrime = pUtils.primeFactors(v)[0]
  print(smallestPrime, end=' ', flush=True)
  seq.append(smallestPrime)
print()