
# euler077.py 
# Project Euler problem 77: Prime Summations
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# https://projecteuler.net/problem=77
'''
What is the first number which can be written 
as the sum of primes in over 5000 different ways?

e.g. 10 can be expressed in 5 ways:
  7+3
  5+5
  5+3+2
  3+3+2+2
  2+2+2+2+2
'''

import pUtils


def numSums(n, prims):
  # dynamic programming build of ways count
  ways = [1]+[0]*n
  for p in prims:
    for i in range(n+1-p):
      ways[i+p] += ways[i]
  return ways[n]


prims = [2]
n = 2
print("(number, number of ways to express using prime sums):")
while True:
  # add the primes up to n
  for i in range(prims[-1]+1, n+1):
    if pUtils.isPrime(i):
      prims.append(i)
  ns = numSums(n, prims)
  print(f"({n},{ns}) ", end='')
  if ns > 5000:
    break
  n += 1
print()   # stops at n == 71, no. ways = 5007
