
# eulerBasel.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Euler, Leonhard (1707-1783), the Basel problem
# https://en.wikipedia.org/wiki/Basel_problem
'''
  pi^2/6 = \sum 1/n^2
  Also see coprimePi.py
'''

import math, time

ns = [ 50, 100, 200, 2000, 20000, 200000, 2000000, 20000000 ]
print("\nBasel PI(n)")
print("       n       Sum           Time taken")
for n in ns:
  start = time.time()
  estPi =  math.sqrt(6*sum([1/(x*x) for x in range(1, n)]))
  end = time.time() - start
  print(f"{n:8d}: {estPi:.15f}; {end:.3f} secs")

print("\n math.pi:", math.pi)
