
# eulerConst.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Euler’s constant
# https://en.wikipedia.org/wiki/Harmonic_series_(mathematics)
# https://en.wikipedia.org/wiki/Euler%27s_constant

import math
import pUtils
from matplotlib import pyplot as plt

limit = 100
ns = list(range(1, limit+1))
hseries = 0
diffs = [0]*(limit+1)
i = 1
for n in ns:
  hseries += 1/n
  diffs[i] = hseries - math.log(n)
  i += 1

plt.plot(ns, diffs[1:])
plt.axhline(y=pUtils.GAMMA, color='red')
plt.ylim(0.4, 1)
plt.xlabel("n")
plt.text(5, pUtils.GAMMA-0.03, "Euler–Mascheroni's Constant")
plt.title('Harmonic series - log n')
plt.show()