
# eulerQuad.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Euler’s quadratic
# https://mathworld.wolfram.com/Prime-GeneratingPolynomial.html

import pUtils

# generate primes from the polynomial x^2 + x + c
def polyPrimes(maxC):
  psDict = {}
  for c in range(1, maxC+1):
    numPrims = 0
    for x in range(1001):
      if pUtils.isPrime(x**2 + x + c):
        numPrims += 1
    psDict[c] = numPrims
  return psDict


maxC = 210

psDict = polyPrimes(maxC)
psDict = dict(sorted(psDict.items(), key=lambda item: item[1]))
        # sort based on the number of primes found for each c
print("(c, Sorted no. of Primes):")
for c, numPrims in psDict.items():
  if numPrims != 0:
    print(f"({c}, {numPrims})", end=' ')
print()