
# factPrimes.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": factorial primes

import math
import pUtils


limit = 20
print("Factorial primes for n = 1 to", limit)
fPs1 = []
fMs1 = []
for n in range(1, limit+1):
  f = math.factorial(n)
  
  # Check if n! + 1 is prime
  fp1 = f + 1
  if pUtils.isPrime(fp1):
    fPs1.append((f"{n}!+1", fp1))
  
  # Check if n! - 1 is prime
  fm1 = f - 1
  if fm1 > 1 and pUtils.isPrime(fm1):
    fMs1.append((f"{n}!-1", fm1))


print("n!+1 primes:")
for expr, p in fPs1:
  print(f" {expr} = {p}")

print("\nn!-1 primes:")
for expr, p in fMs1:
  print(f" {expr} = {p}")


