
# fermatFact.py
# David Wells - "Prime Numbers": factorization, methods of; Fermat's algorithm
# https://en.wikipedia.org/wiki/Fermat's_factorization_method
# input: 5959  or  11
'''
Given an odd integer n > 1, this algorithm 
either produces a single factorization of n or 
proves n prime. 
'''

import random, math


def fermatFact(n):
  # for an odd integer n > 1
  a = int(math.sqrt(n)) + 1
  b2 = a*a - n
  d = 1
  while math.isqrt(b2)**2 != b2:
    b2 += 2*a + d
    d += 2   # no square ends in 2, 3, 7, 8
    if math.sqrt(b2) >= n/3:
      print(f"{n} is prime")
      return 1, n
  x = math.isqrt(n + b2)
  y = math.isqrt(b2)
  return x-y, x+y


n = int(input("n? "))
f1, f2 = fermatFact(n)
print(f"Two factors are {f1} and {f2}")

