
# firoozbakht.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# https://en.wikipedia.org/wiki/Firoozbakht%27s_conjecture

'''
Firoozbakht's prime conjecture asserts that the sequence of prime numbers grows in such a way that the n-th prime p_n satisfies:
p_n+1 < p_n ^(1 + 1/n)

In other words, the ratio between consecutive primes becomes smaller as n increases.
'''

import pUtils

limit = 30
ps = pUtils.primesNum(limit)

print(" P1  P2  bound  P2<bound")
for i in range(1, limit):
  p_n = ps[i-1]
  p_next = ps[i]
  bound = p_n**(1 + (1/(i)))
  satisfies = p_next < bound
  print(f"{p_n:3d} {p_next:3d} {bound:6.2f}  {satisfies}")
