
# gaps.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": gaps between primes and composite runs
# https://en.wikipedia.org/wiki/Prime_gap
# Also see gapsPlot.py, gapsBar.py, gapsCramer.py

import pUtils


limit = 1000000
primes = pUtils.primes(limit)
maxGap = 0
# the sequence of maximal gaps
print("gap     p_n     n")
for i in range(0, len(primes)-1):
  gap = primes[i+1] - primes[i]
  if gap > maxGap:
    maxGap = gap
    print(f"{maxGap:3d} {primes[i]:7d} {(i+1):5d}")
