
# gaussDistPlot.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Gauss and the distribution of primes
# https://en.wikipedia.org/wiki/Prime_number_theorem

import math
import matplotlib.pyplot as plt
import pUtils

limit = 5000002
STEP = 10000
 # plot coordinates in STEPs up to limit

psSet = set(pUtils.primes(limit))

xs = []
ys = []
pCount = 0
for x in range(2, limit, STEP):
  xs.append(x)
  n = x
  # count the primes in this step
  while n < x+STEP:
    if n in psSet:
      pCount += 1
    n += 1
  ys.append(pCount/(n/math.log(n)))

plt.plot(xs, ys)
plt.title("(primes count)/(x/ln x)")
plt.show()
