
# goldbachWeak.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Goldbach's conjecture (weaker)
# https://en.wikipedia.org/wiki/Goldbach%27s_conjecture
# input: 1001
'''
Goldbach's Weak Conjecture (also called the odd Goldbach 
conjecture) states that every odd number greater than 5 
can be expressed as the sum of three prime numbers. 
This conjecture was proved by Harald Helfgott in 2013.
'''

import math
import pUtils

import math

def weakGoldbach(n, ps):
  if n <= 5 or (n % 2 == 0):
    return None
  # find a combination
  for i in range(len(ps)):
    for j in range(i, len(ps)):
      for k in range(j, len(ps)):
        if ps[i] + ps[j] + ps[k] == n:
          return (ps[i], ps[j], ps[k])
  return None


limit = 10000 
prims = pUtils.primes(limit)

n = int(input("odd n? "))
t = weakGoldbach(n, prims)
if t != None:
  print(f"{n} = {t[0]} + {t[1]} + {t[2]}")
else:
  print(f"{n} cannot be expressed as the sum of three primes.")
