
# goodPrimes.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": good primes
# https://mathworld.wolfram.com/GoodPrime.html
# https://oeis.org/A028388
'''
Generate primes p(n), where p(n)^2 > p(n-i)*p(n+i) 
for all i in the range 1 to n-1
'''

import pUtils

def goodPrimes(prims, limit):
  goods = []
  for n in range(1, limit):   
    # exclude 2 and out of primes range tests
    pn = prims[n]
    isGood = True
    for i in range(1, n+1):  # using primes list indicies
      if not (pn**2 > (prims[n-i] * prims[n+i])):
        isGood = False
        break
    if isGood:
      goods.append(pn)
  return goods


limit = 100 
prims = pUtils.primesNum(limit*2)
print(*goodPrimes(prims, limit))

