
# grimm.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Grimm's problem
# https://en.wikipedia.org/wiki/Grimm%27s_conjecture
# inputs: 1802 1803 1804 1805 1806 1807 1808 1809 1810
'''
Grimm's conjecture states that to each element of a set 
of consecutive composite numbers we can assign a distinct 
prime that divides it.
'''

import pUtils

comps = list(map(int, input("consecutive composites? ").split()))
fs = []
for comp in comps:
  fs.append( pUtils.primeFactors(comp))

print("Unique divisibles:")
for i in range(len(fs)):
  uniques = []
  for elem in fs[i]:
    if not any(elem in facts for facts in fs[:i]+fs[i+1:]):
      uniques.append(elem)
  print(" ", comps[i], uniques)
