
# home.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": home prime
# https://en.wikipedia.org/wiki/Home_prime
# https://oeis.org/A037274
# input: 30   or  4  or 8
'''
  Start with any number and form a new number by 
  concatenating its prime factors, starting with the least. 
  Then repeat: 30 = 2 * 3 * S -> 235 = 5 * 47 -> 547, 
  which is prime, and the home prime of 30.
'''

import pUtils

def concat(factors):
  return int(''.join(map(str, factors)))


n = int(input("n? "))
while not pUtils.isPrime(n):
  factors = pUtils.factorizeList(n)
  n2 = concat(factors)
  print(f"{n}: {factors} --> {n2}")
  n = n2
print(n, "is prime")
