
# inconsummate.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": inconsummate number
# https://oeis.org/A003635
'''
A consummate number c is a non-negative integer that can 
be formed by some integer n divided by the the digital 
sum of n.

For instance, c = 47 is a consummate number.
   846 / (8 + 4 + 6) = 47

Integers that can not be formed by a ratio of any integer over 
its digital sum are known as inconsummate numbers.
'''

import pUtils

limit = 300
consummates = [True] + [False]*(limit-1)

for n in range(1, 20*limit):  # hacky
  quot, rem = divmod(n, pUtils.sumDigits(n))
  if rem == 0 and quot < limit:
    consummates[quot] = True

for i, isCon in enumerate(consummates):
  if not isCon:
    print(i, end=' ')
print()
