
# jumpChamp.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": jumping champion; champion numbers
# https://mathworld.wolfram.com/JumpingChampion.html
# https://t5k.org/glossary/page.php?sort=JumpingChampion
# input:  100 or 137  or 180

import pUtils
from collections import Counter

n = int(input("n? "))
prims = pUtils.primes(n+1)

# calculate the differences between adjacent elements
diffs = [prims[i+1] - prims[i] for i in range(len(prims)-1)]
diffCounts = Counter(diffs) 

# print most common differences
tops = diffCounts.most_common()
maxCount = tops[0][1]
for top in tops:
  topDiff = top[0]
  count = top[1]
  if count == maxCount:
    print("Most common difference is", topDiff, "with count:", count)
    for i in range(len(prims)-1):
      if prims[i+1] - prims[i] == topDiff:
        print(f"({prims[i]},{prims[i+1]})", end =' ')
    print()

