
# ktuples.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": k-tuples conjecture, prime
# https://en.wikipedia.org/wiki/Prime_k-tuple
# https://t5k.org/glossary/page.php?sort=PrimeKTuplet

import itertools
import pUtils


def genKTuples(k, limit, pattern):
  pTups = []
  for n in range(2, limit):
    candidate = [n + offset for offset in pattern]
    if all(pUtils.isPrime(p) for p in candidate):
      pTups.append(candidate)
  return pTups


patterns = {
  'twin': [0, 2],            # Twin primes
  'cousin': [0, 4],          # cousin primes
  'trip': [0, 2, 6],         # triplet
  'quad': [0, 2, 6, 8],      # quadruplet
  'quin': [0, 2, 6, 8, 12],  # quintuplet
}

print("K-tuple types: twin, cousin, trip, quad, quin")
KTtype = input("Type? ")  
k = len(patterns[KTtype])
limit = 1000 

pTups = genKTuples(k, limit, patterns[KTtype])
print(f"{len(pTups)} Prime {k}-tuples ({KTtype}) up to {limit}:")
for pt in pTups:
  print(pt, end=' ')
print()

