
# landau4.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Landau, Edmund (prob 3)
# https://en.wikipedia.org/wiki/Landau%27s_problems
# Also see legendre.py
'''
Landau's fourth prime problem asks whether there are infinitely many primes of the form n^2+1

Where n is a positive integer, and p is a prime. 
Some examples of primes in this form are known:
  2^2+1=5, 4^2+1=17, 6^2+1=37, etc.
'''
import math
import pUtils

limit = 100 
prims = [(n**2+1) for n in range(1, limit+1)
                       if pUtils.isPrime(n**2+1)]
print(f"Primes of the form n^2 + 1 for n up to {limit}:")
print(prims)
