
# lucasLehmer.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Lucas, Edouard (1842-1891), Lucas-Lehmer test, and Mersenne numbers and Mersenne primes 
# https://en.wikipedia.org/wiki/Lucas%E2%80%93Lehmer_primality_test
# input:  7  or  or 8  or  18
'''
Mersenne primes M_n for specific n include
n = 2,3,5,7,13,17,19,31,61,89,107,127, etc.
'''

def lucasLehmer(n):
  if n < 2:
    return False
  mn = (1 << n) - 1   # M_n = 2^n - 1
  s = 4
  for _ in range(n-2):
    s = (s*s - 2) % mn
  # should be 0 for M_n to be prime
  return (s == 0)


n = int(input("n for M_n? "))
print( lucasLehmer(n))

