
# lucasSeq.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Lucas, Edouard (1842-1891), the Lucas sequence
# https://en.wikipedia.org/wiki/Lucas_number
# input: 10 or 20
# Also see fibs.py

import math


def lucasSeq(n):
  a = 2  # first Lucas numbers: L0, L1
  b = 1
  if n <= 0: 
    return a 
  elif n == 1:
    return b
  else:
    for i in range(2, n+1): 
      a, b = b, a + b 
    return b 


# ------ main ---------- 

n = int(input("n? "))
print(f"Lucas numbers: 0-{n}:")
for i in range(n+1):
  print(lucasSeq(i), end=' ')  
print()
