
# lucky.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": lucky numbers
# https://en.wikipedia.org/wiki/Lucky_number
# https://oeis.org/A000959

import pUtils

def genLuckies(nums):
  idx = 1 # start at second number in list
  while idx < len(nums):
    n = nums[idx]  
    currSz = len(nums)
    del nums[n-1::n]  # delete in n steps to end
    if len(nums) == currSz:  # no change
      break
    # print(f"Deleted in steps of {n}:\n", nums)
    if n in nums:  # move on if n still in list
      idx += 1
  return nums

limit = 70
nums = list(range(1, limit+1)) 
print("Original list:\n", nums)
luckies = genLuckies(nums)
print("\nLuckies up to", limit, ":")
print(*luckies)


print("\n  limit luckies  primes")
for limit in [1000, 10000, 100000, 1000000]:
  nums = list(range(1, limit+1))
  print(f"{limit:7d}  {len(genLuckies(nums)):5d}  {pUtils.pi(limit):5d}")
