
# magic.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells-"Prime Numbers": magic squares
# https://en.wikipedia.org/wiki/Magic_square
# https://www.geeksforgeeks.org/magic-square-even-order/
# input: 3  or  5
'''
Magic squares are divided into three major categories 
depending upon order of square. 
1) Odd order Magic Square. Example: 3,5,7,… (2*n +1) 

2) Doubly-even order Magic Square. Example : 
   4,8,12,16,.. (4*n) 

3) Singly-even order Magic Square. Example : 
   6,10,14,18,..(4*n +2)
'''

def magicOdd(n):
  # https://www.geeksforgeeks.org/magic-square/
  # Harshit Agrawal
  sqr = [[0 for x in range(n)] for y in range(n)]

  i = n//2
  j = n-1
  num = 1
  while num <= n*n:
    if i == -1 and j == n: # 3rd condition
      j = n-2
      i = 0
    else:
      # next number goes off right side
      if j == n:
        j = 0
      # next number goes off upper side
      if i < 0:
        i = n-1
    if sqr[int(i)][int(j)]: # 2nd condition
      j = j-2
      i += 1
      continue
    else:
      sqr[int(i)][int(j)] = num
      num += 1
    j += 1
    i = i-1 # 1st condition
  return sqr


def printSqr(sqr):
  n = len(sqr)
  for i in range(n):
    for j in range(n):
      print(f"{sqr[i][j]:3d}", end=' ')
    print()



n = int(input("odd n? "))
if n%2 == 1:  # odd
  sqr = magicOdd(n)
  printSqr(sqr) 

