
# mertensTheorem.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Mertens Theorem (third)
# https://en.wikipedia.org/wiki/Mertens%27_theorems
'''
Mertens' third theorem states that:
product form p ≤ n pf (1−1/p) approx= e^(−γ)/log⁡(n)
where p is prime
'''

import math
import pUtils

print("Difference between product and expr for n")
for i in range(1, 7):
  n = 10**i
  prims = pUtils.primes(n+1)
  prodRPs = math.prod([(1-1/p) for p in prims])
  exp = math.exp(-pUtils.GAMMA)/math.log(n)
  print(f"10^{i}.  {prodRPs-exp}")

