
# consecDigits.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": mixed bag (bullet 7)
# https://oeis.org/A006055

import pUtils


def isConsec(n):
  digits = [int(x) for x in str(n)]
  for  i in range(len(digits)-1):
    if (digits[i] == 9) and (digits[i+1] == 0):
      continue
    if digits[i]+1 != digits[i+1]:
      return False
  return True


limit = 10000000
print(f"Primes < {limit} with consecutive (ascending) digits:")
prims = pUtils.primes(limit)
for p in prims:
  if isConsec(p):
    print(p, end=' ')
print()
