
# mixed-sum4n3.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": mixed bag (last bullet)
'''
Every number greater than 55 is the sum of distinct 
primes of the form 4n + 3
'''

import itertools
import pUtils


def is4n3(p):
  val = (p-3)/4
  return int(val) == val


def isSumPrimes(n, primes):
  for r in range(1, len(primes)+1):
    for combo in itertools.combinations(primes, r):
      if sum(combo) == n:
        # print(n, combo)
        return True
  return False


prims = [p for p in pUtils.primes(1000) if is4n3(p)]
print("Max 4n+3 prime generated:", prims[-1])

limit = 500
print(f"Checking from 20 to {limit} for NOT being sums:")
idx = 0
checkPs = []
for i in range(20, limit):
  while (idx < len(prims)) and (prims[idx] <= i):
    checkPs.append(prims[idx])
    idx += 1
  # print("check", checkPs)
  if not isSumPrimes(i, checkPs):
    print(i, end=' ')
print()

