
# mixed-sumppow.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": mixed bag (bullet 5)
'''
The number 1549 is the only odd number less than 10,000 
that is not the sum of a prime and a power.
'''

import pUtils
import math


def isPower(num):
  if num <= 1: 
    return False
  for base in range(2, int(math.sqrt(num)) + 1):
    b = base
    while b <= num:
      if b == num:
        return True
      b = b*base
  return False


def isSumPrimePower(n):
  # Check all primes less than n
  for p in range(2, n):
    if pUtils.isPrime(p) and isPower(n-p):
      return True
  return False


limit = 5000
print(f"Odds < {limit} NOT the sum of a prime and power:")
for i in range(3, limit+1, 2):
  if not isSumPrimePower(i):
    print(i, end=' ')
print()