
# odd.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": odd numbers as p + 2a^2
'''
The conjecture is false that every odd number can be 
written as p + 2a^2, where p is 1 or a prime, and a can 
be 0. But only two counterexamples are known: 5777 and 5993.
'''

import pUtils
import math

def isTwoSquare(n):
  for i in range(0, int(math.sqrt(n/2))+1):
     if 2*i*i == n:
       return True
  return False

def isSumPrimeSqr(n):
  # Check all primes less than n
  if n == 1:
    return True
  for p in range(2, n+1):
    if pUtils.isPrime(p) and isTwoSquare(n-p):
      return True
  return False


limit = 10000
print(f"Checking odd numbers < {limit}:")
for i in range(1, limit, 2):
  if not isSumPrimeSqr(i):
    print(i, end=' ')
print()