
# pandigitals.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": pandigital primes
# https://en.wikipedia.org/wiki/Pandigital_number
# https://oeis.org/A050288
# https://oeis.org/A050290

import itertools
import pUtils

limit = 10
digits = '10123456789' 
print(f"First {limit} pandigital primes using '{digits}':")
i = 0 
for perm in itertools.permutations(digits):
  n = int(''.join(perm))
  if pUtils.isPrime(n):
    print(n)
    i += 1
    if i > limit:
      break
