
# pepin.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Pépin’s test for Fermat numbers
# https://en.wikipedia.org/wiki/P%C3%A9pin%27s_test
# input:  4  or  6
'''
  First few Fermat numbers: n = 0 to 7
    3, 5, 17, 257, 65537, 4294967297, 
    18446744073709551617, 
    340282366920938463463374607431768211457, ...

  The only known Fermat primes are the first five 
  Fermat numbers: F0=3, F1=5, F2=17, F3=257, and F4=65537.
'''

def pepin(n):
  # fn = 2**(2**n) + 1
  fn = (1 << (1 << n)) + 1
  res = pow(3, (fn-1)//2, fn)
  return (res == fn-1)


n = int(input("n for F_n? "))
print(f"is F_{n} = 2^2^{n} + 1 prime?", pepin(n))

