
# permutable.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": permutable primes
# https://en.wikipedia.org/wiki/Permutable_prime

import itertools
import pUtils


def permutationsArePrime(n):
  perms = set(int(''.join(p)) 
              for p in itertools.permutations(str(n)))  
  for perm in perms:
    if not pUtils.isPrime(perm):
      return [] 
  return perms


limit = 500
ps = set()
for i in range(2, limit+1):
  if pUtils.isPrime(i) and (not i in ps):
    ps.update( permutationsArePrime(i) )

psLimit = [p for p in sorted(ps) if p <= limit]
print(*psLimit)

      
