
# piPrimes.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": pi, primes in the decimal expansion of
# https://www.gavalas.dev/blog/spigot-algorithms-for-pi-in-python/
# Konstantinos Gavalas 
# inputs: 10  or 40

import pUtils

def lamberts_pi():
  # generator for digits of pi
  k, a, b, a1, b1 = 2, 4, 1, 12, 4
  while True:
    p, q, k = k*k, 2*k+1, k+1
    a, b, a1, b1 = a1, b1, p*a + q*a1, p*b + q*b1
    d, d1 = a/b, a1/b1
    while d == d1:
      yield int(d)
      a, a1 = 10*(a % b), 10*(a1 % b1)
      d, d1 = a/b, a1/b1


def list2int(numList):
  return int(''.join(map(str,numList)))


n = int(input("n? "))
piGen = lamberts_pi()

digs = []
i = 0
while i < n:
  d = next(piGen)
  digs.append(d)
  num = list2int(digs)
  if pUtils.isPrime(num):
    print(i+1, ":", num)
  i += 1

