
# polignacConj.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Polignac's conjecture
# https://en.wikipedia.org/wiki/Polignac%27s_conjecture
# input: 2   4   6
import pUtils


def polignacPairs(n, limit):
  """Find pairs of primes that differ by n up to a specified limit."""
  ps = pUtils.primes(limit)
  pairs = []
  prime_set = set(ps)  # To allow O(1) average time complexity for lookups
  for prime in ps:
    if prime + n in prime_set:
      pairs.append((prime, prime + n))
  return pairs


n = int(input("even n? "))  # any even integer
limit = 100 
pairs = polignacPairs(n, limit)
print(f"{len(pairs)} pairs of primes differing by {n} up to {limit}:")
for pair in pairs:
  print(pair)
