
# polignacObs.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Polignac or obstinate numbers
# https://oeis.org/A133122  (except for the 3)
# https://sprott.physics.wisc.edu/pickover/obstinate.html
'''
  Odd numbers which cannot be written as the sum of an 
  odd prime and 2^i with i > 0. 
'''

import math
import pUtils

def isPower2(n):
  base = int(math.log2(n))
  return 2**base == n

def isObstinate(n):
  # can an odd number n not be expressed as p + 2^i?
  for p in range(2, n):
    if pUtils.isPrime(p) and isPower2(n-p):
      # print(p, n-p)
      return False
  return True


limit = 1000
print(f"Obstinate numbers in 3-{limit}:")
for i in range(3, limit, 2):
  if isObstinate(i):
    print(i, end = ' ')  
print()