
# powerful.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": powerful numbers
# https://en.wikipedia.org/wiki/Powerful_number
# https://oeis.org/A001694

import pUtils

def genDiffs(lst):
  diffs = set()
  for i in lst:
    for j in lst:
      if i > j: 
        diffs.add(i - j)
  return diffs


limit = 10000
pows = []
for i in range(1, limit+1):
  factPows = pUtils.factorizeDict(i).values()
  if all(p >= 2 for p in factPows):
    pows.append(i)

print(f"Powerfuls from 1 up to {limit}:")
print(*pows)

limit = 100
diffs = genDiffs(pows)
print(f"\nDiffs from 1 to {limit} not generatable from these powerfuls:")
for i in range(1, limit+1):
  if i not in diffs:
    print(i, end=' ')
print()



