
# pretender.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": prime pretender
# https://oeis.org/A000790
'''
A prime pretender to base b) is 
any composite number, n, that satisfies the equation 
n^b ≡ n (mod b). This is a less restrictive than 
Fermat's Little Theorem, which says that if b
and n are coprime, then n^(p-1) ≡ 1 (mod p), 
and so there are more exceptions than the pseudoprimes 
that misleadingly satisfy Fermat's Little Theorem.
'''

import pUtils


def getPretender(n):
  base = 4
  while (pow(n, base, base) != (n % base)) or \
        pUtils.isPrime(base):
    base += 1
  return base 


limit = 20
print("Pretender for i to", limit)
for i in range(0, limit+1):
  print( getPretender(i), end =' ')
print()