
# primFactors.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": primitive prime factor
# https://mathworld.wolfram.com/PrimitivePrimeFactor.html

import pUtils


def primPrimeFacts(nums):
  numPpfs = {}   # number : primitive prime factors
  seenFacts = set()
  for n in nums:
    facts = pUtils.primeFactors(n)
    ppfs = [f for f in facts if f not in seenFacts]
    numPpfs[n] = ppfs
    seenFacts.update(ppfs)
  return numPpfs


limit = 15
print(f"Primitive prime factors for {limit} (k^2+1):")
nums = [k*k+1 for k in range(1, limit+1)]
numPpfs = primPrimeFacts(nums)
print("  n  ppf")
for n, pfs in numPpfs.items():
  print(f"{n:3d} ", *pfs)
