
# primegraph.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": prime number graph
# https://en.wikipedia.org/wiki/Prime_number

import pUtils
import matplotlib.pyplot as plt


def link(p1, p2, prims, plt, col='red'):
  x1 = prims.index(p1)+1
  x2 = prims.index(p2)+1
  plt.plot([x1,x2], [p1,p2], color=col, lw=1)


limit = 50
primes = pUtils.primes(limit)
xs = range(1, len(primes)+1)

plt.scatter(xs, primes)

link(3,7, primes, plt, 'orange')
link(5,23, primes, plt)
link(7,13, primes, plt, 'green')
link(29,41, primes, plt)
link(19,47, primes, plt, 'orange')

# Label each dot with the corresponding prime number
for i, prime in enumerate(primes):
  plt.text(i+1, prime, "  "+str(prime), fontsize=9, 
                     ha='left', va='center')

plt.title("Prime Numbers up to " + str(limit))
plt.xlabel("n")
plt.ylabel("Prime Number $P_n$")

plt.xticks(xs) 
plt.yticks(range(0, limit+1, 5)) 

# Show grid in steps of 1
plt.grid(True, which='both', linestyle='--', linewidth=0.5)
plt.show()
