
# primorials.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": primorial, compositional
# https://en.wikipedia.org/wiki/Primorial

import pUtils
import matplotlib.pyplot as plt


limit = 15
primes = pUtils.primesNum(limit)

prims = []
# the nth primorial is the product of the first n prime numbers. 
prim = 1
for p in primes:
  prim *= p
  prims.append(prim)


plt.plot(range(1, len(prims)+1), prims, marker='o', 
                                 linestyle='dashed')
plt.yscale('log')  # better visualization
plt.title('Primorials')
plt.xticks(range(1, len(prims)+1))
plt.xlabel('Prime Index')
plt.ylabel('Primorial (Log Scale)')
plt.grid(True)
plt.show()
