
# proth.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Proth's theorem
# https://en.wikipedia.org/wiki/Proth_prime
'''
A Proth number is of the form 
N = k*2^n + 1,  where k and n are positive integers, 
k is odd, and 2^n > k  A Proth prime is a Proth number 
that is prime. 
'''

import pUtils


limit_k = 100  # Maximum value of k (odd numbers)
limit_n = 10   # Maximum value of n

print(f"Proth primes with k upto {limit_k} and n upto {limit_n}:")
pNums = []
for k in range(1, limit_k+1, 2):  # k must be odd
  for n in range(1, limit_n+1):
    if 2**n > k:
      pNum = k * 2**n + 1
      if pUtils.isPrime(pNum):
        pNums.append(pNum)

ps = sorted(pNums)
print(*[p for p in ps if p < 10000])
