
# pyramid.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": pyramid, prime
# https://planetmath.org/primepyramid

import math
import itertools
import pUtils


def isRowValid(row):
  # Check that first number is 1 and last is row number
  if row[0] != 1 or row[-1] != len(row):
    return False
  # Check if all adjacent pairs sum to a prime number
  for i in range(len(row) - 1):
    if not pUtils.isPrime(row[i] + row[i+1]):
      return False
  return True


def genPossibleRows(level):
  # Generate all permutations of numbers from 1 to level
  nums = list(range(1, level+1))
  return [p for p in itertools.permutations(nums)
                              if isRowValid(p)]


levels = 7
for level in range(2, levels+1):
  print(f"Valid rows for level {level}:")
  for row in genPossibleRows(level):
    print(' ', *row)
