
# quadRes.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": quadratic residues
# https://en.wikipedia.org/wiki/Quadratic_residue
# input:  11  or  13  or  17 (4n+1)   or 19  (4n+3)


def quadResidues(n):
  # Generate a list of quadratic residues modulo n
  rs = set() 
  for i in range(1, n):
    res = (i*i) % n 
    rs.add(res)
  nonrs = set(range(1, n)) - rs
  return sorted(rs), sorted(nonrs)


n = int(input("n? ")) 
rs, nonrs = quadResidues(n)
print("[Residues] No. ; [Non-residues] No.")
print(rs, len(rs), ";", nonrs, len(nonrs))

