
# repunits.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": repunits, prime
# https://en.wikipedia.org/wiki/Full_reptend_prime
# https://mathworld.wolfram.com/RepunitPrime.html
# Also see decRecur.py

import pUtils


def reportPrimes(base, rus):
  ruPs = [ru for ru in rus
               if pUtils.isPrimeMR( int(ru, base))]
  print("\nn for prime R_n of base", base)
  print(' ', *[len(ru) for ru in ruPs])



limit = 400
print(f"Using repunits R_1 to R_{limit}")
repunits = ['1'*i for i in range(1, limit+1)]

reportPrimes(3, repunits)
reportPrimes(5, repunits)
reportPrimes(10, repunits)

