
# siamese.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Siamese primes
# https://t5k.org/curios/page.php/95479.html

import pUtils

limit = 1000
sPairs = []
for n in range(2, limit+1):
  a = n**2 - 2
  b = n**2 + 2
  if pUtils.isPrime(a) and pUtils.isPrime(b):
    sPairs.append((a, b))

print(f"Siamese pairs for n <= {limit}:")
print(*sPairs)
