
# sloane.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Sloane's OEIS (bullet 4)
# https://oeis.org/A015919
'''
  Positive integers k such that 2^k == 2 (mod k). 
  Includes 341 which is first pseudoprime to base 2 
  and distinguishes sequence from the primes + 1.
'''

import pUtils

def isValid(n): 
  return pow(2,n,n) == 2%n


limit = 700
nprims = [k for k in range(1, limit) if isValid(k)]
print(f"Near primes < {limit}:")
print(nprims)

print("\nOld primes:")
primsOld = [1]+pUtils.primes(limit)
print(primsOld)

diffs = [item for item in nprims if item not in primsOld]
print("\nDifferences (and factors):")
for d in diffs:
  print(" ", d, pUtils.primeFactors(d))