
# smooth.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": smooth numbers
# https://en.wikipedia.org/wiki/Smooth_number
# input: 5   or   10
'''
A smooth number (or k-smooth number) is a number whose 
prime factors are all less than or equal to a given value k. 
For example, a 5-smooth number has all its prime factors 
less than or equal to 5 (i.e., its prime factors can only 
be 2, 3, or 5).
'''

import pUtils

def isSmooth(n, k):
  factors = pUtils.primeFactors(n)
  return all(f <= k for f in factors)


limit = 100
k = int(input("k? "))
smooths = []
for num in range(2, limit):
  if isSmooth(num, k):
    smooths.append(num)
print(f"{len(smooths)} {k}-smooth numbers up to {limit}")
print(smooths)