
# spiralSacks.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
'''
Uses turtle graphics rather than matplotlib to get
an animation effect.

https://en.wikipedia.org/wiki/Ulam_spiral#Variants
https://numberspiral.com/index.html
https://sevko.io/articles/prime-number-spirals/

Also see spiral.py, spiralUlam.py
'''

import math
from turtle import Turtle
import pUtils

SZ = 500
MAX_NUM = 15000

def spiral(t):
  for i in range(0, MAX_NUM):
    dist = math.sqrt(i)
    angle = math.radians(360 * dist)
    radius = dist * 2
    x = math.cos(angle) * radius
    y = math.sin(angle) * radius
    t.goto(x,y)
    if pUtils.isPrime(i):
      t.dot(3)

t = Turtle()
t.speed(0) 
t.hideturtle()
t.pencolor("blue")
t.penup()
scr = t.getscreen()
scr.screensize(SZ, SZ)
scr.setup(SZ+40, SZ+40)
scr.delay(0)
scr.title("Sacks spiral")
spiral(t)
print("finished")
scr.exitonclick()
