
# stern.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Stern primes
# https://en.wikipedia.org/wiki/Stern_prime
# https://oeis.org/A042978

import pUtils


def isStern(p):
  ''' A Stern prime is a prime NOT of the form 
    p + 2n^2 where p is a prime and n > O. 
  '''
  for n in range(1, int((p/2)**0.5) + 1):
    q = p - 2*(n**2)
    if q > 1 and pUtils.isPrime(q):
      return False
  return True


limit = 5000
for p in range(2, limit):
  if pUtils.isPrime(p) and isStern(p):
    print(p, end=' ')
print()

