
# twinsPlot.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": twin primes
# https://en.wikipedia.org/wiki/Twin_prime
# https://t5k.org/howmany.html
# Also see HardyL1.py

import matplotlib.pyplot as plt
import pUtils


def countTwinsUpTo(limit):
  counts = []
  count = 0
  for i in range(3, limit+1):
    if pUtils.isPrime(i) and pUtils.isPrime(i+2):
      count += 1
    counts.append(count)
  return counts


limit = 1000
counts = countTwinsUpTo(limit)

plt.plot(range(3, limit+1), counts)
plt.xlabel("n")
plt.ylabel("Count < n")
plt.title(f"Number of Twin Primes Less Than {limit}")
plt.show()
