
# wilson.py
# Andrew Davison, ad@coe.psu.ac.th, Nov. 2024
# David Wells - "Prime Numbers": Wilson's theorem
# https://en.wikipedia.org/wiki/Wilson%27s_theorem
# Also see formWilson.py

import pUtils
import math


def isWilson(prime):
  return (math.factorial(prime-1) % prime) == prime-1


def isWilson2(n):   
  # n is prime iff (n−1)! ≡ −1 (mod n)
  fact = 1 
  for i in range(2, n):
     fact = (fact*i)%n
  return fact == (n-1)



limit = 100
prims = pUtils.primes(limit)
print(f"Test Wilson's Theorem for primes < {limit}:")
for p in prims:
  print(f"({p}: {isWilson(p)})", end=' ')
print()
